#if 0
include,"linalg.i";
n = 5;
a = random(n,n)-0.5;
a = a(+,)*a(+,);
SVdec(a);
eigen(a);
eirs(a,implicit=1);
eirs(a);

func test_eigen(n)
{
  if (is_void(n)) n = 11;
  a = random(n,n) - 0.5;
  a = a + transpose(a);
  (id = array(double, n, n))(1:n*n:n+1) = 1.0;

  t0 = t1 = array(double, 3);
  
  local u, vt;
  timer, t0;
  s = SVdec(a,u,vt);
  timer, t1; ms = 1e3*(t1 - t0);
  write, format="SVD: cpu=%.3f sys=%.3f wall=%.3f (ms)\n",
    ms(1), ms(2), ms(3);
  
  timer, t0;
  l = eirs(a);
  timer, t1; ms = 1e3*(t1 - t0);
  write, format="EIRS(TRED1 TQLRAT): cpu=%.3f sys=%.3f wall=%.3f (ms)\n",
    ms(1), ms(2), ms(3);

  al = abs(l);
  stat, al(sort(al)(::-1)) - s;
  
  timer, t0;
  z0 = 1;
  l0 = eirs(a, z0, implicit=0);
  timer, t1; ms = 1e3*(t1 - t0);
  write, format="EIRS(TRED2 TQL2): cpu=%.3f sys=%.3f wall=%.3f (ms)\n",
    ms(1), ms(2), ms(3);
  stat, z0(,+)*(l0(-,)*z0)(,+) - a;
  stat, z0(,+)*z0(,+) - id;
  stat, z0(+,)*z0(+,) - id;
  
  
  timer, t0;
  z1 = 1;
  l1 = eirs(a, z1, implicit=1);
  timer, t1; ms = 1e3*(t1 - t0);
  write, format="EIRS(TRED2 IMTQL2): cpu=%.3f sys=%.3f wall=%.3f (ms)\n",
    ms(1), ms(2), ms(3);
  stat, z1(,+)*(l1(-,)*z1)(,+) - a;
  stat, z1(,+)*z1(,+) - id;
  stat, z1(+,)*z1(+,) - id;
}

#endif

extern _ssiev
/* PROTOTYPE
   void ssiev_d(double array a, long lda, long n, double array e,
                double array work, int job, long array ierr);
 */

extern _eirs
/* PROTOTYPE
   void ant_eirs_d(double array a, long lda, long n, double array e, pointer z,
                   double array work, long flags, long array ierr);
*/

func eirs(a, &z, implicit=)
{
  /* we must check the dimension list of A to avoid segmentation
     fault when calling low-level EISPACK routine */
  if (! is_array(a) || structof(a) == complex
      || (dims = dimsof(a))(1) != 2 || (n = dims(2)) != dims(3)) {
    error, "expecting a non-complex symmetric square matrix";
  }

  ierr = 0; /* long integer */
  opts = (implicit ? 4 : 0)
  e = array(double, n);
  work = array(double, 2*n);
  if (z) {
    z = double(a);
    _eirs, z, n, n, e, &z, work, opts, ierr;
  } else {
    a = double(a); /* force copy */
    _eirs, a, n, n, e, &[], work, opts, ierr;
  }
  if (ierr) error, "the eigenvalue iteration fails to converge";
  return e;

}


func eigen(a, &z)
/* DOCUMENT e = eigen(a)
       -or- e = eigen(a, z)

     returns the eigenvalues of real symmetric matrix A.  In the second
     form, also store the eigenvectors in output symbol Z (only works
     if Z is not nil on entry).
        A = Z.diag(E).Z'

     For instance:
        z = 1; // define symbol Z before calling function
        e = eigen(a, z);
        
   SEE ALSO:
 */
{
  /* we must check the dimension list of A to avoid segmentation
     fault when calling low-level EISPACK routine */
  if (! is_array(a) || structof(a) == complex
      || (dims = dimsof(a))(1) != 2 || (n = dims(2)) != dims(3)) {
    error, "expecting a non-complex symmetric square matrix";
  }

  ierr = 0; /* long integer */
  job = ! is_void(z);
  z = double(a);
  e = array(double, n);
  work = array(double, 2*n);
  _ssiev, z, n, n, e, work, job, ierr;
  if (ierr) error, "the eigenvalue iteration fails to converge";
  return e;
}
